unit urepldragdrop;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, SDL_replist;

type
  TForm1 = class(TForm)
    RLLeft: TReportListView;
    RLRight: TReportListView;
    Label1: TLabel;
    BButExit: TBitBtn;
    procedure RLMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure BButExitClick(Sender: TObject);
    procedure RLDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormShow(Sender: TObject);
    procedure RLDragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  SDL_filesys;

(******************************************************************************)
procedure TForm1.RLMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
(******************************************************************************)

var
  GridCell : TGridCoord;

begin
GridCell := TReportListView(Sender).MouseCell(x,y);
if (ssLeft in Shift) and (GridCell.Y > 0) and
   (TReportListView(Sender).NrOfRows > 0) then
  TReportListView(Sender).BeginDrag (false, 20);
end;

(******************************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(******************************************************************************)

begin
close;
end;


(******************************************************************************)
procedure TForm1.RLDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
(******************************************************************************)

var
  GridCell : TGridCoord;

begin
Accept := false;
if Source is TReportListView then
  if Source <> Sender then
    begin
    GridCell := TReportListView(Sender).MouseCoord(x, y-(TReportListView(Sender).DefaultRowHeight div 2));
    TReportListView(Sender).InterRowIndicatorPos := GridCell.Y-TReportListView(Sender).CountHeadRows+2;
    Accept := true;
    end;
end;


(******************************************************************************)
procedure TForm1.FormShow(Sender: TObject);
(******************************************************************************)

const
  Firstnames : array[1..6] of string = ('Claire', 'John','Patty','Woody','Jim','Barbara');
  Lastnames  : array[1..5] of string = ('Smith','Mailer','Henderson','Illiadus','Mayer');

var
  i : integer;

begin
RLLeft.InterRowIndicatorColor := clBlue;
RLLeft.Header[1] := 'Name';
RLLeft.Header[2] := 'Password';
RLRight.Header[1] := 'Name';
RLRight.Header[2] := 'Password';
randomize;
for i:=1 to RLLeft.NrOfRows do
  begin
  RLLeft[1,i] := FirstNames[1+random(6)]+' '+LastNames[1+random(5)];;
  RLLeft[2,i] := Inventpassword(8);
  end;
for i:=1 to RLRight.NrOfRows do
  begin
  RLRight[1,i] := FirstNames[1+random(6)]+' '+LastNames[1+random(5)];
  RLRight[2,i] := Inventpassword(8);
  end;
end;


(******************************************************************************)
procedure TForm1.RLDragDrop(Sender, Source: TObject; X, Y: Integer);
(******************************************************************************)

var
  i          : integer;
  destrow    : integer;
  NRow       : integer;

begin
if Source is TReportListView then   { source is list of chapters }
  begin
  if Source <> Sender then
    begin
    TReportListView(Source).SuppressPaint := True;
    TReportListView(Sender).SuppressPaint := True;
    destrow := TReportListView(Sender).InterRowIndicatorPos;
    NRow := TReportListView(Source).NrOfRows;
    for i:= NRow downto 1 do
      begin
      if TReportListView(Source).RowSelected[i] then
        begin
        destrow := TReportListView(Sender).InsertRow (destrow);
        TReportListView(Sender)[1,destrow] := TReportListView(Source)[1,i];
        TReportListView(Sender)[2,destrow] := TReportListView(Source)[2,i];
        TReportListView(Source).InterRowIndicatorPos := 0;
        TReportListView(Sender).InterRowIndicatorPos := 0;
        TReportListView(Source).RemoveRow (i);
        end;
      end;
    TReportListView(Source).SuppressPaint := false;
    TReportListView(Sender).SuppressPaint := false;
    end;
  end;
end;


end.
